aboutsummaryrefslogtreecommitdiffstats
path: root/src/extract-nix.sh
diff options
context:
space:
mode:
authorLibravatar Alexander Foremny <aforemny@posteo.de>2023-09-05 15:49:19 +0200
committerLibravatar Alexander Foremny <aforemny@posteo.de>2023-09-05 16:00:14 +0200
commitebd9664313c0a1984fc9a06d0e247e4832212957 (patch)
treebf97f06e739be4e8a5dc1a231f5f513233917698 /src/extract-nix.sh
parent4c019f382762f55e9595b151e186cf360d0605fa (diff)
*.sh -> src
Diffstat (limited to 'src/extract-nix.sh')
-rwxr-xr-xsrc/extract-nix.sh44
1 files changed, 44 insertions, 0 deletions
diff --git a/src/extract-nix.sh b/src/extract-nix.sh
new file mode 100755
index 0000000..e092db2
--- /dev/null
+++ b/src/extract-nix.sh
@@ -0,0 +1,44 @@
+#!/usr/bin/env bash
+
+set -efu
+
+input_file=${1-/dev/stdin}
+
+tree-grepper \
+ --query nix '((comment)+)' \
+ --format json $input_file |
+ jq 'sort_by(.file)' |
+ jq '.[]' --indent 0 |
+ while read -r line; do
+ file=$(echo "$line" | jq -r .file)
+ file_type=$(echo "$line" | jq -r .file_type)
+ items=$(echo "$line" |
+ jq '.matches[] | { file: $file, file_type: $file_type, match: . }' --arg file "$file" --arg file_type "$file_type" |
+ jq '. | select(.match.text | test("TODO .+"))'
+ )
+ if test -z "$items"; then
+ continue
+ fi
+
+ echo "$items" | jq --slurp '.[]' --indent 0 |
+ while read -r item; do
+ start_row=$(echo "$item" | jq '.match.start.row')
+ end_row=$(echo "$item" | jq '.match.end.row')
+
+ last_commit=$(git --no-pager blame -L "$start_row,$start_row" "$file" -p |
+ head -n 1 |
+ cut -d ' ' -f 1
+ )
+
+ text=$(echo "$item" |
+ jq .match.text -r |
+ sed 's/^# *TODO *//' |
+ sed 's/^\/\* *TODO *//' |
+ sed 's/ *\*\/$//')
+
+ echo "$item" | jq '. + {"text": $text, "last_commit": $last_commit}' \
+ --arg text "$text" \
+ --arg last_commit "$last_commit" \
+ -c
+ done
+ done